# -*- coding: utf-8 -*-
"""
Created on Wed Nov 26 08:59:26 2014
updated 12/24/2014 with acquistion interface
@author: TomK
using grid layout techniques
added multiple tasks to update GUI
"""
from Tkinter import *     #gui module
from isaaccomv2 import *  #isaac module
import math
from sqlite_log_insert import *  #sqlite database module
#import time
from datetime import datetime,timedelta
from sysgmail import *    #email module
log_file = ' '
value =0
setwrite=0 #control for file initialization

root = Tk()
tv1 = IntVar()
tvx =0
tv4 = StringVar() 
#this sould be 60 purge and 90 second sense =150
sample_time_ms =150000  #150 seconds
time_val_high =60  # 5V
time_val_low =90 # 1.4V MQ-7

mytext=Text(root, height=10, width =40)

def show_run():
    print "show run envoked"
    tv4.set('   ')
    print "for RUN you requested:"
    print "CO selection: "+ str(Ck1_value.get())
    print "LPG selection: "+ str(Ck2_value.get())
    print "VOC selection: "+ str(Ck3_value.get())
    print "Log selection: "+ str(Ck4_value.get())
    print "# of samples: "+ str(tv1.get())
   # value = tv1.get()
    root.after(1,task1)  #first time to update display
    mytext.delete("1.0",END) #clear log viewer
    
def email():
    send_email(str(tv2.get()),str(tve.get()))  

def db():
    logtoDB(str(tv2.get()))
    
    
def show_log():
    print "you requested log view"
    mytext.delete(1.0,END)   # clear textwidget
    if Ck4_value.get() ==True: 
        #
        try:
            
            fhandle = open(str(tv2.get()))
            lines = fhandle.read()
            fhandle.close()
            mytext.insert(END, lines)
        except IOError:
            #
        
            print ('Cannot find log view file' )  
    else:
        print ('log file does not exist')

#this is the  purge cycle of acquistion check # of samples before continuing execution
def task2():
    #
    global tvx
    global time_val_low
    print 'sample task2 envoked'
    tvx = tv1.get()
    if (tvx==0):
        print('sampling complete')
        return
   # time.sleep(sample_time_ms/1000) # emulate sampling time
    echo,acknack = API_com('Z'+'09'+'00050'+'0000'+'999999')
    print (echo,acknack)
    echo,acknack=API_com('L02') # green off red on
     #print (echo,acknack)
    echo,acknack=API_com('H01')
           #print (echo,acknack)
    time.sleep(time_val_high) # 60 seconds
   

    root.after(1,task3)  #recall task3 after 1 millisecond
# this is the sense cycle collects formats and stores samples
def task3():
    
    global setwrite
    global tvx
    global time_val_low
    print 'task 3 envoked'
    echo,acknack=API_com('H02')
           #print (echo,acknack)
    echo,acknack=API_com('L01')
           #print (echo,acknack)
    echo,acknack = API_com('Z'+'09'+'00050'+'0000'+'005600')
           # echo,acknack= PWM ('09','076')# 1.5V
    print (echo,acknack)
    time.sleep(time_val_low)        
           
    API_com('L01')
   
    tvx=tvx-1;
    
    tv1.set(tvx)
    print (' task 3 samples remaining  = '+ str(tvx))
    if Ck4_value.get() ==True: 
        try:
            #printto log_file
            if setwrite==0:
                f = open(str(tv2.get()),'w')
                setwrite =1
            else:
                f = open(str(tv2.get()),'a')
            #begin acquistion based upon user selection
            
            mydate =datetime.now()
            f.write(str(mydate.year)+':'+str(mydate.month)+':'+ str (mydate.day)+ ':'+str(mydate.hour)+':'+str(mydate.minute)+':'+str(mydate.second)+ ',')
             #CO
            if Ck1_value.get() ==True: 
               #
            
               echo1,ADC_data= API_ADC('14')   # digitize CO value
               v =ADC_data*3.3/1023 # convert to voltage
               voltage = '%*.*f' % (1,3,v)
               p = 0.125* math.exp(2.0422*v)  # CO PPM
               ppm= '%*.*f' % (4,2,p)
               print('CO voltage = ' +voltage)
               print('CO PPM =' + ppm)
               f.write(voltage +',')
               f.write(ppm +',')
             
            else:
                 
               f.write(' '+',')  
               f.write(' '+',')
            if Ck2_value.get() ==True:     #LPG
               echo1,ADC_data= API_ADC('15')   # digitize LPG value
               v =ADC_data*3.3/1023 # convert to voltage
               voltage = '%*.*f' % (1,3,v)
               p = 0.5534* math.exp(2.1877*v)  # LPG PPM
               ppm= '%*.*f' % (4,2,p)
               print('LPG voltage = ' +voltage)
               print('LPG PPM =' + ppm)
               f.write(voltage +',')
               f.write(ppm +',')  
            else:
               f.write(' '+',')
               f.write(' '+',')
            if Ck3_value.get() ==True:     #VOC
               echo1,ADC_data= API_ADC('16')   # digitize VOC value
               v =ADC_data*3.3/1023 # convert to voltage
               voltage = '%*.*f' % (1,3,v)
               p = 0.1575* math.exp(1.724*v)  # VOC PPM
               ppm= '%*.*f' % (4,2,p)
                  
               print('VOC voltage = ' +voltage)
               print('VOC PPM =' + ppm)
               f.write(voltage +',')
               f.write(ppm +'\n')
            else:
               f.write(' '+',')
               f.write(' '+'\n')
        
            f.close()
        except IOError:
            print ('Cannot find file' )
    else:
        # this is debug really just prints voltages no real formatting
                      #no logging #co
        if Ck1_value.get() ==True:
            #
      
            echo1,ADC_data= API_ADC('14')   # digitize CO value
            v =ADC_data*3.3/1023 # convert to voltage
            voltage = '%*.*f' % (1,3,v)
            print('CO voltage = ' +voltage)
                   
               
        if Ck2_value.get() ==True:     #VCO
            echo1,ADC_data= API_ADC('15')   # digitize LPG value
            v =ADC_data*3.3/1023 # convert to voltage
            voltage = '%*.*f' % (1,3,v)
            print('LPG voltage = ' +voltage)
                   
               
        if Ck3_value.get() ==True:     #LPG
            echo1,ADC_data= API_ADC('16')   # digitize VCO value
            v =ADC_data*3.3/1023 # convert to voltage
            voltage = '%*.*f' % (1,3,v)
            print('VOC voltage = ' +voltage)
                  
    API_com('L02') #GREEN OFF        
    print'end task3'
    PWM('09','000')
       
    
    root.after(1,task2)  #recall task2 after 1 millisecond
    
#task1 invoked start of run, determines time to acquire based upon sample count, names the log file, initializes IO then launches task2 
def task1():
    global setwrite
   
    print 'task1 envoked'
    sample_time_sec =sample_time_ms/1000
    process_time = sample_time_sec* int(tv1.get())
    print"Run Time will take " +str(process_time)+ " seconds"
#    process_time = process_time/60 #minutes
#    print " or " +str(process_time)+ " minutes"
    mydate =datetime.now()
    #test =10
    d =timedelta(seconds =process_time)
    newdate = mydate+d
 #   current = str(mydate.month)+ str (mydate.day)+ str(mydate.hour)+':'+str(mydate.minute)+':'+str(mydate.second)
    completion = str(newdate.year)+':'+str(newdate.month)+':'+ str (newdate.day)+ ':'+str(newdate.hour)+':'+str(newdate.minute)+':'+str(newdate.second)
    tv4.set(completion)
    #set file name
    if Ck4_value.get() ==True: 
        
        tv2.set('log_'+str(mydate.month)+'_'+ str (mydate.day)+ '_'+str(mydate.hour)+'_'+str(mydate.minute)+'_'+str(mydate.second)+'.txt')
        log_file = str(tv2.get())
        print ('The log file name is ' +log_file)
    setwrite =0 
   
  # initializae ISaSC  Gas interface
    echo,acknack =API_com('O01')  # red led
    print (echo,acknack)
    echo,acknack =API_com('O01')  # red led
    print (echo,acknack)
    echo,acknack =API_com('O02')  # green led
    print (echo,acknack)
    echo,acknack=PWM('09','000')# off pwm
    print (echo,acknack)
    echo, acknack =API_com('L01')
    print (echo,acknack)
    echo,acknack=API_com('L02')
    print (echo,acknack)
    API_com('I14')                      #API to set pin A0 to input CO
    print (echo,acknack)
    API_com('I15')                      #API to set pin A1 to input VCO
    print (echo,acknack)
    API_com('I16')                      #API to set pin A0 to input LPG
    print (echo,acknack)
   
    root.after(120,task2)
    

#GUI display build
root.title('Indoor Air Quality Monitoring Prototype Tools Suite')
Ck4_value  = BooleanVar()
# add label to to myframe1
Label(root,borderwidth=3,bg='#4ef17f', text='Gas Selection').grid (row =0,column =0,sticky='w')
#add check button widgets to myframe1
Ck1_value  = BooleanVar()
Ck2_value  = BooleanVar()
Ck3_value  = BooleanVar()
Ck1_value.set(False)
Ck2_value.set(False)
Ck3_value.set(False)
Ck1 =Checkbutton(root, text='Enable C0  Monitor',variable= Ck1_value).grid (row =1,column =0,sticky='w')
Ck2= Checkbutton(root, text='Enable LPG Monitor',variable= Ck2_value).grid (row =2,column =0,sticky='w')
Ck3= Checkbutton(root, text='Enable VOC Monitor',variable= Ck3_value).grid (row =3,column =0,sticky='w')

lb2 =Label(root,bg ='#c0ff3e', text=' Log control').grid (row =0,column =2,sticky='w')
lb3= Label(root, text='File Name: ').grid (row =1,column =2,sticky='w')
tv2 = StringVar() #discussed later
en2 =Entry(root, textvariable=tv2).grid (row =2,column =2,sticky='e',padx=4,pady=4)
tv2.set(log_file)

Ck4_value.set(False)
Ck4= Checkbutton(root, text='Enable Log',variable= Ck4_value).grid (row =3,column =2,sticky='w')


Label(root, bg ='#cd6090', text='Acquistion Control').grid (row =0,column =3,sticky='w')
#add logging control
#tv1 = IntVar()

lb1= Label(root, text=' # of samples').grid (row =1,column =3,sticky='w')

tv1.set("0")  
en1 =Entry(root, textvariable=tv1)
en1.grid (row =2,column =3,sticky='e',padx=4,pady=4)


#en1.bind("<Return>",note)

but1 =Button(root, bg ='#cd6090',text='Run', command = show_run).grid (row =3,column =3,sticky='w')

lb4= Label(root, text=' Est.Completion Time').grid (row =4,column =3,sticky='w')
lb5=Label(root, text='YYYY:MM:DD:MM:SS').grid (row =5,column =3,sticky='w')

tv4.set(' ')
en4 =Entry(root, textvariable=tv4)
en4.grid (row =6,column =3,sticky='e',padx=4,pady=4)

Label(root,borderwidth=3,bg='#4ef17f', text='Log Viewer').grid (row =6,column =0,sticky='w')
mytext=Text(root, height=10, width =60)
mytext.grid (row =7,column =0,sticky='w',padx=5,pady=5)

#add scrollbar widget to the text widget
sb = Scrollbar(root, orient=VERTICAL, command=mytext.yview)
sb.grid (row =7,column =0,sticky='e')

mytext.configure(yscrollcommand=sb.set)
but2 =Button(root, bg ='#c0ff3e',text='View Log', command = show_log).grid (row =7,column =2,sticky='w',padx=6,pady=4)

Label(root,bg='#4ec17f', text='Advanced Apps').grid (row =0,column =4,sticky='w')
but3 =Button(root, bg ='#4ec17f',text='Update DB', command = db).grid (row =7,column =4,sticky='w',padx=6,pady=4)

but4 =Button(root,bg ='#4ec17f',text='Send Email', command = email).grid (row =3,column =4,sticky='w')
lbe= Label(root, text='Email Address').grid (row =1,column =4,sticky='w')
tve = StringVar()
tve.set("YOUR EMAIL ADDR")
ene =Entry(root, textvariable=tve)
ene.grid (row =2,column =4,sticky='e',padx=4,pady=4)



#mysocket= socket.gethostbyname(socket.getfqdn())
#print mysocket
#root.after(2000,task)
root.mainloop()